module LazyIO(LazyIO, runLazyIO) where

import System.IO.Unsafe
import Control.Monad.Trans

newtype LazyIO a = LazyIO { getLazyIO :: a }

runLazyIO :: LazyIO a -> IO a
runLazyIO = return . getLazyIO
{-# INLINE runLazyIO #-}

instance Monad LazyIO where
    return = LazyIO
    {-# INLINE return #-}
    (LazyIO a) >>= f = f a
    {-# INLINE (>>=) #-}

instance MonadIO LazyIO where
    liftIO = LazyIO . unsafePerformIO


