module TrimSpace where

import Text.XML.HaXml
import Data.Char

documentTrimSpace :: Document a -> Document a
documentTrimSpace (Document p e c m) = Document p e (elementTrimSpace c) m

elementTrimSpace :: Element a -> Element a
elementTrimSpace (Elem n a cs) = Elem n a (filter e $ map contentTrimSpace cs)
    where 
    e (CString _ "" _) = False
    e _ = True

contentTrimSpace :: Content a -> Content a
contentTrimSpace (CElem e i) = CElem (elementTrimSpace e) i
contentTrimSpace (CString False c i) = CString False (dropWhile isSpace c) i
contentTrimSpace e = e


